1. 程式人生 > >【HDU - 1025】Constructing Roads In JGShining's Kingdom(dp最長上升子序列模型 + 二分優化)

【HDU - 1025】Constructing Roads In JGShining's Kingdom(dp最長上升子序列模型 + 二分優化)

題幹:

Constructing Roads In JGShining's Kingdom

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 29933    Accepted Submission(s): 8496


 

Problem Description

JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines.

Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities). Each poor city is short of exactly one kind of resource and also each rich city is rich in exactly one kind of resource. You may assume no two poor cities are short of one same kind of resource and no two rich cities are rich in one same kind of resource.

With the development of industry, poor cities wanna import resource from rich ones. The roads existed are so small that they're unable to ensure the heavy trucks, so new roads should be built. The poor cities strongly BS each other, so are the rich ones. Poor cities don't wanna build a road with other poor ones, and rich ones also can't abide sharing an end of road with other rich ones. Because of economic benefit, any rich city will be willing to export resource to any poor one.

Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.

The location of Rich City 1 is on the left of all other cities, Rich City 2 is on the left of all other cities excluding Rich City 1, Rich City 3 is on the right of Rich City 1 and Rich City 2 but on the left of all other cities ... And so as the poor ones.

But as you know, two crossed roads may cause a lot of traffic accident so JGShining has established a law to forbid constructing crossed roads.

For example, the roads in Figure I are forbidden.



In order to build as many roads as possible, the young and handsome king of the kingdom - JGShining needs your help, please help him. ^_^

 

 

Input

Each test case will begin with a line containing an integer n(1 ≤ n ≤ 500,000). Then n lines follow. Each line contains two integers p and r which represents that Poor City p needs to import resources from Rich City r. Process to the end of file.

 

 

Output

For each test case, output the result in the form of sample.
You should tell JGShining what's the maximal number of road(s) can be built.

 

 

Sample Input

2

1 2

2 1

3

1 2

2 3

3 1

 

Sample Output

Case 1: My king, at most 1 road can be built. Case 2: My king, at most 2 roads can be built.

Hint

Huge input, scanf is recommended.

解題報告:

下面介紹一下o(nlogn)的上升子序列做法:

    就是求最長上升子序列,一開始用的普通辦法求的!直接TEL;就在網上找了一個時間複雜度為O(nlogn)的演算法,其演算法思想為:(網上找的)

假設要尋找最長上升子序列的序列是a[n],然後尋找到的遞增子序列放入到陣列b中。

(1)當遍歷到陣列a的第一個元素的時候,就將這個元素放入到b陣列中,以後遍歷到的元素都和已經放入到b陣列中的元素進行比較;

(2)如果比b陣列中的每個元素都大,則將該元素插入到b陣列的最後一個元素,並且b陣列的長度要加1;

(3)如果比b陣列中最後一個元素小,就要運用二分法進行查詢,查找出第一個比該元素大的最小的元素,然後將其替換。

在這個過程中,只重複執行這兩步就可以了,最後b陣列的長度就是最長的上升子序列長度。例如:如該數列為:

5 9 4 1 3 7 6 7

那麼:

5 //加入
5 9 //加入
4 9 //用4代替了5
1 9 //用1代替4
1 3 //用3代替9
1 3 7 //加入
1 3 6 //用6代替7
1 3 6 7 //加入

最後b中元素的個數就是最長遞增子序列的大小,即4。

要注意的是最後數組裡的元素並不就一定是所求的序列,

例如如果輸入 2 5 1

那麼最後得到的陣列應該是 1 5

而實際上要求的序列是 2 5

AC程式碼:

#include<bits/stdc++.h>
using namespace std;
const int MAXN=500010;
int a[MAXN],b[MAXN];

//用二分查詢的方法找到一個位置,使得num>b[i-1] 並且num<b[i],並用num代替b[i]
//手寫upper_bound 
//int Search(int num,int low,int high) {
//	int mid;
//	while(low<=high) {
//		mid=(low+high)/2;
//		if(num>=b[mid])  low=mid+1;
//		else   high=mid-1;
//	}
//	return low;
//}
int DP(int n) {
	int len,pos;
	b[1]=a[1];
	len=1;
	for(int i=2; i<=n; i++) {
		if(a[i]>=b[len]) { //如果a[i]比b[]陣列中最大還大直接插入到後面即可
			b[++len]=a[i];
		} else { //用二分的方法在b[]陣列中找出第一個比a[i]大的位置並且讓a[i]替代這個位置
			//pos=Search(a[i],1,len);
			pos = upper_bound(b+1,b+len+1,a[i]) - b;
			b[pos]=a[i];
		}
	}
	return len;
}
int main() 
{
	int n;
	int iCase=0,x,y;
	while(scanf("%d",&n)!=EOF) {
		for(int i=1; i<=n; i++) {
			scanf("%d%d",&x,&y);
			a[x]=y;
		}
		int res=DP(n);
		printf("Case %d:\n",++iCase);
		if(res==1) {
			printf("My king, at most 1 road can be built.\n\n");
		} else
			printf("My king, at most %d roads can be built.\n\n",res);
	}
	return 0;
}

ps:其實DP函式中應該是a[i]>b[len],但是因為這個題的題乾和資料特殊性,確保了不會出現兩次重複的數字,所以加上等號也可以ac。